export default class BuildConfiguration<ResultType> {
    required: Set<string>;
    readonly ignores: Set<string>;
    readonly transformers: {
        [localPath: string]: ValueTransformer;
    };
    readonly aliases: {
        [localPath: string]: string;
    };
    readonly listElementConstructors: {
        [localPath: string]: ResultType;
    };
    require(...paths: string[]): this;
    ignore(...paths: string[]): this;
    transform(localPath: string, transformerIn: Action, transformerOut?: Action): this;
    alias(foreignPath: string, localPath: string): this;
    listType(localPath: string, builtObject: ResultType): this;
}
//# sourceMappingURL=BuildConfiguration.d.ts.map