import { a as BuildableResource } from './Builder-d121c3a0.js';

var ResourceDecorator = (function () {
    function ResourceDecorator() {
    }
    ResourceDecorator.prototype.Resource = function (constructor) {
        var target = constructor.prototype;
        if (!(target instanceof BuildableResource)) {
            throw new Error("Target class has to extend BuildableResource in order to use this decorator.");
        }
        if (!target.constructor) {
            throw new Error("Target class must have a constructor with no arguments.");
        }
    };
    ResourceDecorator.prototype.Alias = function (alias) {
        return function (target, name) {
            var _a;
            (_a = target.buildConfig) === null || _a === void 0 ? void 0 : _a.alias(alias, name.toString());
        };
    };
    ResourceDecorator.prototype.Transform = function (transformerIn, transformerOut) {
        return function (target, name) {
            var _a;
            (_a = target.buildConfig) === null || _a === void 0 ? void 0 : _a.transform(name, transformerIn, transformerOut);
        };
    };
    ResourceDecorator.prototype.Required = function (target, name) {
        var _a;
        (_a = target.buildConfig) === null || _a === void 0 ? void 0 : _a.require(name.toString());
    };
    ResourceDecorator.prototype.Ignore = function (target, name) {
        var _a;
        (_a = target.buildConfig) === null || _a === void 0 ? void 0 : _a.ignore(name.toString());
    };
    ResourceDecorator.prototype.ListOf = function (resource) {
        return function (target, name) {
            var _a;
            (_a = target.buildConfig) === null || _a === void 0 ? void 0 : _a.listType(name, new resource());
        };
    };
    return ResourceDecorator;
}());
var resourceDecorator = new ResourceDecorator();
var Resource = resourceDecorator.Resource;
var Alias = resourceDecorator.Alias;
var Transform = resourceDecorator.Transform;
var Ignore = resourceDecorator.Ignore;
var Required = resourceDecorator.Required;
var ListOf = resourceDecorator.ListOf;

var decorators = /*#__PURE__*/Object.freeze({
    __proto__: null,
    Resource: Resource,
    Alias: Alias,
    Transform: Transform,
    Ignore: Ignore,
    Required: Required,
    ListOf: ListOf
});

export { Alias as A, Ignore as I, ListOf as L, Resource as R, Transform as T, Required as a, decorators as d };
